diff -cr duel/duelgdb.c \emx\gnu\duel/duelgdb.c
*** duel/duelgdb.c	Sat Mar 20 16:35:48 1993
--- \emx\gnu\duel/duelgdb.c	Sat Aug 12 09:24:00 1995
***************
*** 95,102 ****
  #include "gdbcmd.h"
  #include "call-cmds.h"
  
! #include "duel/src/global.h"
! #include "duel/src/proto.h"
  
  /* all duel memory allocation go thru here */
  
--- 95,104 ----
  #include "gdbcmd.h"
  #include "call-cmds.h"
  
! #include "global.h"
! #include "proto.h"
! 
! typedef struct frame_info *FRAME;
  
  /* all duel memory allocation go thru here */
  
***************
*** 184,190 ****
   * otherwise, duel access target's memory directly.
   */
  
! LPROC duel_convert_value_from_gdb(value gv, tvalue *dv)
  {
    dv->ctype=duel_convert_type_from_gdb(VALUE_TYPE(gv));
    if(VALUE_LVAL(gv) == lval_memory) {
--- 186,192 ----
   * otherwise, duel access target's memory directly.
   */
  
! LPROC duel_convert_value_from_gdb(value_ptr gv, tvalue *dv)
  {
    dv->ctype=duel_convert_type_from_gdb(VALUE_TYPE(gv));
    if(VALUE_LVAL(gv) == lval_memory) {
***************
*** 210,218 ****
   * by making a gdb lvalue. but i am not sure how/what
   */
  
! LFUNC value convert_duel_val_to_gdb_val(tvalue *v)
  {
!    value gv ; 
     if(v->val_kind!=VK_RVALUE) return 0 ; /* cant handle lvals */
     switch(v->ctype->type_kind) {
  /* duel standardize func parms, so this code is not required. if this
--- 212,220 ----
   * by making a gdb lvalue. but i am not sure how/what
   */
  
! LFUNC value_ptr convert_duel_val_to_gdb_val(tvalue *v)
  {
!    value_ptr gv ; 
     if(v->val_kind!=VK_RVALUE) return 0 ; /* cant handle lvals */
     switch(v->ctype->type_kind) {
  /* duel standardize func parms, so this code is not required. if this
***************
*** 258,264 ****
  PROC duel_target_func_call(tvalue *func, tvalue *parms[],
                              int parms_no,tvalue *rval)
  {
!     value gfunc, grval, gparms[20] ;
      int i ;
      struct type *gftype ;
  
--- 260,266 ----
  PROC duel_target_func_call(tvalue *func, tvalue *parms[],
                              int parms_no,tvalue *rval)
  {
!     value_ptr gfunc, grval, gparms[20] ;
      int i ;
      struct type *gftype ;
  
***************
*** 369,374 ****
--- 371,383 ----
  	   if((char) -1 != -1) ct=ctype_char ;
  	   else ct=ctype_uchar ;
        }
+ #if 1
+       /* New type names used by GCC 2.5 (Eberhard Mattes, 23-Jun-1994) */
+       else if(strcmp(TYPE_NAME(t),"long int")==0)  ct=ctype_long ;
+       else if(strcmp(TYPE_NAME(t),"long unsigned int")==0)  ct=ctype_ulong ;
+       else if(strcmp(TYPE_NAME(t),"short int")==0) ct=ctype_short ;
+       else if(strcmp(TYPE_NAME(t),"short unsigned int")==0) ct=ctype_ushort ;
+ #endif
        break;
     case TYPE_CODE_FLT:
        if(strcmp(TYPE_NAME(t),"float")==0)  ct=ctype_float ;
***************
*** 492,498 ****
    FRAME frame ;
    struct block *blk ;
    int len ;
!   value gv ;                    /* gdb value */
  
    if(frame_no== -1) {           /* use the user selected frame and block */
        frame = selected_frame ;  
--- 501,507 ----
    FRAME frame ;
    struct block *blk ;
    int len ;
!   value_ptr gv ;                /* gdb value */
  
    if(frame_no== -1) {           /* use the user selected frame and block */
        frame = selected_frame ;  
***************
*** 506,512 ****
    if(!sym) {		/* look up the symbol that has no debug info*/
       struct minimal_symbol *m ;
       if(frame_no != -1) return FALSE ; /* only locals looked up- not found*/
!      m=lookup_minimal_symbol (name,NULL); /* find printf, malloc etc */
       if(m == NULL) return FALSE ;
       v->val_kind=VK_LVALUE ;
  #ifdef SYMBOL_LANGUAGE
--- 515,521 ----
    if(!sym) {		/* look up the symbol that has no debug info*/
       struct minimal_symbol *m ;
       if(frame_no != -1) return FALSE ; /* only locals looked up- not found*/
!      m=lookup_minimal_symbol (name,NULL,NULL); /* find printf, malloc etc */
       if(m == NULL) return FALSE ;
       v->val_kind=VK_LVALUE ;
  #ifdef SYMBOL_LANGUAGE
***************
*** 551,557 ****
  {
     FRAME frame=duel_select_frame(frame_no);
     struct symbol *sym = get_frame_function(frame);
!    value val = read_var_value(sym,frame);
     duel_assert(val!=0 && VALUE_LVAL(val) == lval_memory);
  
     return (ttarget_ptr) VALUE_ADDRESS(val) ;
--- 560,566 ----
  {
     FRAME frame=duel_select_frame(frame_no);
     struct symbol *sym = get_frame_function(frame);
!    value_ptr val = read_var_value(sym,frame);
     duel_assert(val!=0 && VALUE_LVAL(val) == lval_memory);
  
     return (ttarget_ptr) VALUE_ADDRESS(val) ;
diff -cr duel/print.c \emx\gnu\duel/print.c
*** duel/print.c	Fri Mar 12 12:01:00 1993
--- \emx\gnu\duel/print.c	Sun Sep  8 15:48:54 1996
***************
*** 191,197 ****
        case CTK_SCHAR:   if(rval.u.rval_schar==0) sprintf(s,"'\\0'");
  		        else sprintf(s,"%d", rval.u.rval_schar)  ; break ;
        case CTK_UCHAR:   if(rval.u.rval_uchar==0) sprintf(s,"'\\0'");
! 		        else sprintf(s,"'\\x%d'", rval.u.rval_uchar)  ; break ;
        case CTK_USHORT:  if(rval.u.rval_ushort==0) sprintf(s,"0");
  		        else sprintf(s,"0x%x",   rval.u.rval_ushort) ; break ;
        case CTK_UINT:    if(rval.u.rval_uint==0) sprintf(s,"0");
--- 191,197 ----
        case CTK_SCHAR:   if(rval.u.rval_schar==0) sprintf(s,"'\\0'");
  		        else sprintf(s,"%d", rval.u.rval_schar)  ; break ;
        case CTK_UCHAR:   if(rval.u.rval_uchar==0) sprintf(s,"'\\0'");
! 		        else sprintf(s,"'\\x%x'", rval.u.rval_uchar)  ; break ;
        case CTK_USHORT:  if(rval.u.rval_ushort==0) sprintf(s,"0");
  		        else sprintf(s,"0x%x",   rval.u.rval_ushort) ; break ;
        case CTK_UINT:    if(rval.u.rval_uint==0) sprintf(s,"0");
